Efficiently update chart data using incremental transactions without replacing the entire dataset. Use Transaction Updates for fast changes to large datasets.
Apply Transaction API Copy Link
The applyTransaction() method allows incrementally updating the chart data without replacing the entire dataset. It returns a Promise that resolves once the transaction has been applied and rendered.
Transaction Operations Copy Link
Transactions support three types of operations: adding, removing, and updating data items. Multiple operations can be combined in a single transaction.
import {
AgChartOptions,
AgCharts,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
interface DataItem {
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
return {
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const options: AgChartOptions = {
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
function addItems() {
const newItems: DataItem[] = [];
for (let i = 0; i < 5; i++) {
newItems.push(createItem());
}
data.push(...newItems);
chart.applyTransaction({ add: newItems });
}
function addAtIndex() {
const newItem = createItem();
const insertIndex = Math.min(2, data.length);
data.splice(insertIndex, 0, newItem);
chart.applyTransaction({ add: [newItem], addIndex: 2 });
}
function removeItem() {
if (data.length === 0) return;
const itemToRemove = data.pop()!;
chart.applyTransaction({ remove: [itemToRemove] });
}
function updateItems() {
if (data.length === 0) return;
const itemsToUpdate = data.slice(0, Math.min(5, data.length));
for (const item of itemsToUpdate) {
item.value = Math.round(random() * 100);
}
chart.applyTransaction({ update: itemsToUpdate });
}
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).addItems = addItems;
(<any>window).addAtIndex = addAtIndex;
(<any>window).removeItem = removeItem;
(<any>window).updateItems = updateItems;
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 5 Items: Appends 5 new items to the end of the dataset.
- Add at Index 2: Inserts a new item at position 2 using
addIndex. - Remove Last: Removes the last item from the dataset.
- Update First 5: Modifies the values of the first 5 items.
By default, items are identified by object reference. To update or remove an item, you must pass the same object instance that exists in the data array.
Alternatively, set dataIdKey to identify items by a unique field instead. See Identifying Items by Key below.
Adding Data Copy Link
Use the add property to append new data items to the dataset.
// Add new items to the end
chart.applyTransaction({
add: [
{ category: 'Item 1', value: 42 },
{ category: 'Item 2', value: 38 },
],
});Use addIndex to control where items are inserted:
// Add item to the beginning
chart.applyTransaction({
add: [{ category: 'Item 0', value: 50 }],
addIndex: 0,
});
// Add item at a specific position
chart.applyTransaction({
add: [{ category: 'Item 3', value: 45 }],
addIndex: 2,
}); Removing Data Copy Link
Use the remove property to remove items from the dataset.
Items are matched by referential equality, meaning you must provide the exact object reference that exists in the data array.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
{ category: 'Item 3', value: 45 },
];
// Later, remove specific items by reference
const itemToRemove = data[0];
chart.applyTransaction({
remove: [itemToRemove],
}); Updating Data Copy Link
Use the update property to modify existing items.
First mutate the item in place, then pass the reference in the transaction.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
];
// Mutate the item in place
const itemToUpdate = data[1];
itemToUpdate.value = 100;
// Notify the chart of the change
chart.applyTransaction({
update: [itemToUpdate],
}); Combined Operations Copy Link
Multiple operations can be performed in a single transaction for efficiency.
chart.applyTransaction({
remove: [oldItems[0], oldItems[1]],
update: [modifiedItem],
add: [
{ category: 'Item 10', value: 62 },
{ category: 'Item 11', value: 58 },
],
});Operations are processed in order: add, then remove, then update.
Identifying Items by Key Copy Link
Set the dataIdKey chart option to a property name on your data items to identify them by that field instead of by object reference.
When dataIdKey is set:
- Remove operations only need the ID field on each item.
- Update operations match by ID and replace the existing datum with the new object.
- Add operations work the same as without
dataIdKey.
dataIdKey also determines the itemId exposed in many node events and states. See Item Identifiers for more details.
import {
AgChartOptions,
AgCharts,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
interface DataItem {
id: string;
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
const id = `item-${nextId}`;
return {
id,
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const options: AgChartOptions = {
dataIdKey: "id",
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
};
options.container = document.getElementById("myChart");
const chart = AgCharts.create(options);
function addItems() {
const newItems: DataItem[] = [];
for (let i = 0; i < 3; i++) {
newItems.push(createItem());
}
data.push(...newItems);
chart.applyTransaction({ add: newItems });
}
function removeById() {
if (data.length === 0) return;
const lastItem = data.pop()!;
// Only need the ID field to remove
chart.applyTransaction({ remove: [{ id: lastItem.id } as any] });
}
function updateById() {
if (data.length === 0) return;
// Create a brand-new object with the same ID
const existing = data[0];
const replacement: DataItem = {
id: existing.id,
category: existing.category,
value: Math.round(random() * 100),
};
data[0] = replacement;
chart.applyTransaction({ update: [replacement] });
}
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).addItems = addItems;
(<any>window).removeById = removeById;
(<any>window).updateById = updateById;
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 3 Items: Appends 3 new items to the dataset.
- Remove Last by ID: Removes the last item using only its
idfield. - Update First by ID: Creates a new object with the same
idto replace the first item.
Setting dataIdKey Copy Link
const options = {
dataIdKey: 'id',
data: [
{ id: 'item-1', category: 'Category A', value: 42 },
{ id: 'item-2', category: 'Category B', value: 58 },
],
// ...
};The values of the dataIdKey field must be unique strings or numbers across the dataset.
Removing by ID Copy Link
When dataIdKey is set, remove items by passing objects containing only the ID field:
chart.applyTransaction({
remove: [{ id: 'item-1' }],
}); Updating by ID Copy Link
Pass a new object with the matching ID. The existing datum is fully replaced:
chart.applyTransaction({
update: [{ id: 'item-2', category: 'Category B', value: 99 }],
});Unlike reference-based updates where you mutate the original object, ID-based updates use replacement semantics — the chart stores the new object in place of the old one.
API Reference Copy Link
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.

Efficiently update chart data using incremental transactions without replacing the entire dataset. Use Transaction Updates for fast changes to large datasets.
Apply Transaction API Copy Link
The applyTransaction() method allows incrementally updating the chart data without replacing the entire dataset. It returns a Promise that resolves once the transaction has been applied and rendered.
The AgChartInstance can be obtained using an Angular @ViewChild decorator to reference our AgCharts tag, which exposes a chart property.
Transaction Operations Copy Link
Transactions support three types of operations: adding, removing, and updating data items. Multiple operations can be combined in a single transaction.
import { Component, ViewChild } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
return {
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<div class="example-controls">
<div class="controls-row">
<button (click)="addItems()">Add 5 Items</button>
<button (click)="addAtIndex()">Add at Index 2</button>
<button (click)="removeItem()">Remove Last</button>
<button (click)="updateItems()">Update First 5</button>
</div>
</div>
<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
@ViewChild(AgCharts)
public agCharts!: AgCharts;
constructor() {
this.options = {
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
};
}
addItems = () => {
const newItems: DataItem[] = [];
for (let i = 0; i < 5; i++) {
newItems.push(createItem());
}
data.push(...newItems);
this.agCharts.chart!.applyTransaction({ add: newItems });
};
addAtIndex = () => {
const newItem = createItem();
const insertIndex = Math.min(2, data.length);
data.splice(insertIndex, 0, newItem);
this.agCharts.chart!.applyTransaction({ add: [newItem], addIndex: 2 });
};
removeItem = () => {
if (data.length === 0) return;
const itemToRemove = data.pop()!;
this.agCharts.chart!.applyTransaction({ remove: [itemToRemove] });
};
updateItems = () => {
if (data.length === 0) return;
const itemsToUpdate = data.slice(0, Math.min(5, data.length));
for (const item of itemsToUpdate) {
item.value = Math.round(random() * 100);
}
this.agCharts.chart!.applyTransaction({ update: itemsToUpdate });
};
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
- Add 5 Items: Appends 5 new items to the end of the dataset.
- Add at Index 2: Inserts a new item at position 2 using
addIndex. - Remove Last: Removes the last item from the dataset.
- Update First 5: Modifies the values of the first 5 items.
By default, items are identified by object reference. To update or remove an item, you must pass the same object instance that exists in the data array.
Alternatively, set dataIdKey to identify items by a unique field instead. See Identifying Items by Key below.
Adding Data Copy Link
Use the add property to append new data items to the dataset.
// Add new items to the end
chart.applyTransaction({
add: [
{ category: 'Item 1', value: 42 },
{ category: 'Item 2', value: 38 },
],
});Use addIndex to control where items are inserted:
// Add item to the beginning
chart.applyTransaction({
add: [{ category: 'Item 0', value: 50 }],
addIndex: 0,
});
// Add item at a specific position
chart.applyTransaction({
add: [{ category: 'Item 3', value: 45 }],
addIndex: 2,
}); Removing Data Copy Link
Use the remove property to remove items from the dataset.
Items are matched by referential equality, meaning you must provide the exact object reference that exists in the data array.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
{ category: 'Item 3', value: 45 },
];
// Later, remove specific items by reference
const itemToRemove = data[0];
chart.applyTransaction({
remove: [itemToRemove],
}); Updating Data Copy Link
Use the update property to modify existing items.
First mutate the item in place, then pass the reference in the transaction.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
];
// Mutate the item in place
const itemToUpdate = data[1];
itemToUpdate.value = 100;
// Notify the chart of the change
chart.applyTransaction({
update: [itemToUpdate],
}); Combined Operations Copy Link
Multiple operations can be performed in a single transaction for efficiency.
chart.applyTransaction({
remove: [oldItems[0], oldItems[1]],
update: [modifiedItem],
add: [
{ category: 'Item 10', value: 62 },
{ category: 'Item 11', value: 58 },
],
});Operations are processed in order: add, then remove, then update.
Identifying Items by Key Copy Link
Set the dataIdKey chart option to a property name on your data items to identify them by that field instead of by object reference.
When dataIdKey is set:
- Remove operations only need the ID field on each item.
- Update operations match by ID and replace the existing datum with the new object.
- Add operations work the same as without
dataIdKey.
dataIdKey also determines the itemId exposed in many node events and states. See Item Identifiers for more details.
import { Component, ViewChild } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
id: string;
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
const id = `item-${nextId}`;
return {
id,
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<div class="example-controls">
<div class="controls-row">
<button (click)="addItems()">Add 3 Items</button>
<button (click)="removeById()">Remove Last by ID</button>
<button (click)="updateById()">Update First by ID</button>
</div>
</div>
<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
@ViewChild(AgCharts)
public agCharts!: AgCharts;
constructor() {
this.options = {
dataIdKey: "id",
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
};
}
addItems = () => {
const newItems: DataItem[] = [];
for (let i = 0; i < 3; i++) {
newItems.push(createItem());
}
data.push(...newItems);
this.agCharts.chart!.applyTransaction({ add: newItems });
};
removeById = () => {
if (data.length === 0) return;
const lastItem = data.pop()!;
// Only need the ID field to remove
this.agCharts.chart!.applyTransaction({
remove: [{ id: lastItem.id } as any],
});
};
updateById = () => {
if (data.length === 0) return;
// Create a brand-new object with the same ID
const existing = data[0];
const replacement: DataItem = {
id: existing.id,
category: existing.category,
value: Math.round(random() * 100),
};
data[0] = replacement;
this.agCharts.chart!.applyTransaction({ update: [replacement] });
};
}
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
- Add 3 Items: Appends 3 new items to the dataset.
- Remove Last by ID: Removes the last item using only its
idfield. - Update First by ID: Creates a new object with the same
idto replace the first item.
Setting dataIdKey Copy Link
const options = {
dataIdKey: 'id',
data: [
{ id: 'item-1', category: 'Category A', value: 42 },
{ id: 'item-2', category: 'Category B', value: 58 },
],
// ...
};The values of the dataIdKey field must be unique strings or numbers across the dataset.
Removing by ID Copy Link
When dataIdKey is set, remove items by passing objects containing only the ID field:
chart.applyTransaction({
remove: [{ id: 'item-1' }],
}); Updating by ID Copy Link
Pass a new object with the matching ID. The existing datum is fully replaced:
chart.applyTransaction({
update: [{ id: 'item-2', category: 'Category B', value: 99 }],
});Unlike reference-based updates where you mutate the original object, ID-based updates use replacement semantics — the chart stores the new object in place of the old one.
API Reference Copy Link
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.

Efficiently update chart data using incremental transactions without replacing the entire dataset. Use Transaction Updates for fast changes to large datasets.
Apply Transaction API Copy Link
The applyTransaction() method allows incrementally updating the chart data without replacing the entire dataset. It returns a Promise that resolves once the transaction has been applied and rendered.
The AgChartInstance can be obtained using a React Ref to our <AgCharts /> tag, which exposes a chart property.
Transaction Operations Copy Link
Transactions support three types of operations: adding, removing, and updating data items. Multiple operations can be combined in a single transaction.
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AgChartsInstance,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
return {
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = () => {
const chartRef = useRef<AgChartsInstance>(null);
const [options, setOptions] = useState<AgChartOptions>({
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
});
const addItems = () => {
const newItems: DataItem[] = [];
for (let i = 0; i < 5; i++) {
newItems.push(createItem());
}
data.push(...newItems);
chartRef.current!.applyTransaction({ add: newItems });
};
const addAtIndex = () => {
const newItem = createItem();
const insertIndex = Math.min(2, data.length);
data.splice(insertIndex, 0, newItem);
chartRef.current!.applyTransaction({ add: [newItem], addIndex: 2 });
};
const removeItem = () => {
if (data.length === 0) return;
const itemToRemove = data.pop()!;
chartRef.current!.applyTransaction({ remove: [itemToRemove] });
};
const updateItems = () => {
if (data.length === 0) return;
const itemsToUpdate = data.slice(0, Math.min(5, data.length));
for (const item of itemsToUpdate) {
item.value = Math.round(random() * 100);
}
chartRef.current!.applyTransaction({ update: itemsToUpdate });
};
return (
<Fragment>
<div className="example-controls">
<div className="controls-row">
<button onClick={addItems}>Add 5 Items</button>
<button onClick={addAtIndex}>Add at Index 2</button>
<button onClick={removeItem}>Remove Last</button>
<button onClick={updateItems}>Update First 5</button>
</div>
</div>
<AgCharts ref={chartRef} options={options} />
</Fragment>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 5 Items: Appends 5 new items to the end of the dataset.
- Add at Index 2: Inserts a new item at position 2 using
addIndex. - Remove Last: Removes the last item from the dataset.
- Update First 5: Modifies the values of the first 5 items.
By default, items are identified by object reference. To update or remove an item, you must pass the same object instance that exists in the data array.
Alternatively, set dataIdKey to identify items by a unique field instead. See Identifying Items by Key below.
Adding Data Copy Link
Use the add property to append new data items to the dataset.
// Add new items to the end
chart.applyTransaction({
add: [
{ category: 'Item 1', value: 42 },
{ category: 'Item 2', value: 38 },
],
});Use addIndex to control where items are inserted:
// Add item to the beginning
chart.applyTransaction({
add: [{ category: 'Item 0', value: 50 }],
addIndex: 0,
});
// Add item at a specific position
chart.applyTransaction({
add: [{ category: 'Item 3', value: 45 }],
addIndex: 2,
}); Removing Data Copy Link
Use the remove property to remove items from the dataset.
Items are matched by referential equality, meaning you must provide the exact object reference that exists in the data array.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
{ category: 'Item 3', value: 45 },
];
// Later, remove specific items by reference
const itemToRemove = data[0];
chart.applyTransaction({
remove: [itemToRemove],
}); Updating Data Copy Link
Use the update property to modify existing items.
First mutate the item in place, then pass the reference in the transaction.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
];
// Mutate the item in place
const itemToUpdate = data[1];
itemToUpdate.value = 100;
// Notify the chart of the change
chart.applyTransaction({
update: [itemToUpdate],
}); Combined Operations Copy Link
Multiple operations can be performed in a single transaction for efficiency.
chart.applyTransaction({
remove: [oldItems[0], oldItems[1]],
update: [modifiedItem],
add: [
{ category: 'Item 10', value: 62 },
{ category: 'Item 11', value: 58 },
],
});Operations are processed in order: add, then remove, then update.
Identifying Items by Key Copy Link
Set the dataIdKey chart option to a property name on your data items to identify them by that field instead of by object reference.
When dataIdKey is set:
- Remove operations only need the ID field on each item.
- Update operations match by ID and replace the existing datum with the new object.
- Add operations work the same as without
dataIdKey.
dataIdKey also determines the itemId exposed in many node events and states. See Item Identifiers for more details.
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
AgChartOptions,
AgChartsInstance,
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
id: string;
category: string;
value: number;
}
let nextId = 1;
function createItem(): DataItem {
const id = `item-${nextId}`;
return {
id,
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData(): DataItem[] {
const items: DataItem[] = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data: DataItem[] = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = () => {
const chartRef = useRef<AgChartsInstance>(null);
const [options, setOptions] = useState<AgChartOptions>({
dataIdKey: "id",
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
});
const addItems = () => {
const newItems: DataItem[] = [];
for (let i = 0; i < 3; i++) {
newItems.push(createItem());
}
data.push(...newItems);
chartRef.current!.applyTransaction({ add: newItems });
};
const removeById = () => {
if (data.length === 0) return;
const lastItem = data.pop()!;
// Only need the ID field to remove
chartRef.current!.applyTransaction({
remove: [{ id: lastItem.id } as any],
});
};
const updateById = () => {
if (data.length === 0) return;
// Create a brand-new object with the same ID
const existing = data[0];
const replacement: DataItem = {
id: existing.id,
category: existing.category,
value: Math.round(random() * 100),
};
data[0] = replacement;
chartRef.current!.applyTransaction({ update: [replacement] });
};
return (
<Fragment>
<div className="example-controls">
<div className="controls-row">
<button onClick={addItems}>Add 3 Items</button>
<button onClick={removeById}>Remove Last by ID</button>
<button onClick={updateById}>Update First by ID</button>
</div>
</div>
<AgCharts ref={chartRef} options={options} />
</Fragment>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 3 Items: Appends 3 new items to the dataset.
- Remove Last by ID: Removes the last item using only its
idfield. - Update First by ID: Creates a new object with the same
idto replace the first item.
Setting dataIdKey Copy Link
const options = {
dataIdKey: 'id',
data: [
{ id: 'item-1', category: 'Category A', value: 42 },
{ id: 'item-2', category: 'Category B', value: 58 },
],
// ...
};The values of the dataIdKey field must be unique strings or numbers across the dataset.
Removing by ID Copy Link
When dataIdKey is set, remove items by passing objects containing only the ID field:
chart.applyTransaction({
remove: [{ id: 'item-1' }],
}); Updating by ID Copy Link
Pass a new object with the matching ID. The existing datum is fully replaced:
chart.applyTransaction({
update: [{ id: 'item-2', category: 'Category B', value: 99 }],
});Unlike reference-based updates where you mutate the original object, ID-based updates use replacement semantics — the chart stores the new object in place of the old one.
API Reference Copy Link
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.

Efficiently update chart data using incremental transactions without replacing the entire dataset. Use Transaction Updates for fast changes to large datasets.
Apply Transaction API Copy Link
The applyTransaction() method allows incrementally updating the chart data without replacing the entire dataset. It returns a Promise that resolves once the transaction has been applied and rendered.
The AgChartInstance can be obtained using the Vue $refs component property to reference our AgCharts tag, which exposes a chart property.
Transaction Operations Copy Link
Transactions support three types of operations: adding, removing, and updating data items. Multiple operations can be combined in a single transaction.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
category: string;
value: number;
}
let nextId = 1;
function createItem() {
return {
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData() {
const items = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = defineComponent({
template: `
<div class="example-controls">
<div class="controls-row">
<button v-on:click="addItems()">Add 5 Items</button>
<button v-on:click="addAtIndex()">Add at Index 2</button>
<button v-on:click="removeItem()">Remove Last</button>
<button v-on:click="updateItems()">Update First 5</button>
</div>
</div>
<ag-charts
ref="agCharts"
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
});
const agCharts = ref(null);
const addItems = () => {
const newItems = [];
for (let i = 0; i < 5; i++) {
newItems.push(createItem());
}
data.push(...newItems);
agCharts.value.chart.applyTransaction({ add: newItems });
};
const addAtIndex = () => {
const newItem = createItem();
const insertIndex = Math.min(2, data.length);
data.splice(insertIndex, 0, newItem);
agCharts.value.chart.applyTransaction({ add: [newItem], addIndex: 2 });
};
const removeItem = () => {
if (data.length === 0) return;
const itemToRemove = data.pop();
agCharts.value.chart.applyTransaction({ remove: [itemToRemove] });
};
const updateItems = () => {
if (data.length === 0) return;
const itemsToUpdate = data.slice(0, Math.min(5, data.length));
for (const item of itemsToUpdate) {
item.value = Math.round(random() * 100);
}
agCharts.value.chart.applyTransaction({ update: itemsToUpdate });
};
return {
options,
agCharts,
addItems,
addAtIndex,
removeItem,
updateItems,
};
},
});
createApp(ChartExample).mount("#app");
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 5 Items: Appends 5 new items to the end of the dataset.
- Add at Index 2: Inserts a new item at position 2 using
addIndex. - Remove Last: Removes the last item from the dataset.
- Update First 5: Modifies the values of the first 5 items.
By default, items are identified by object reference. To update or remove an item, you must pass the same object instance that exists in the data array.
Alternatively, set dataIdKey to identify items by a unique field instead. See Identifying Items by Key below.
Adding Data Copy Link
Use the add property to append new data items to the dataset.
// Add new items to the end
chart.applyTransaction({
add: [
{ category: 'Item 1', value: 42 },
{ category: 'Item 2', value: 38 },
],
});Use addIndex to control where items are inserted:
// Add item to the beginning
chart.applyTransaction({
add: [{ category: 'Item 0', value: 50 }],
addIndex: 0,
});
// Add item at a specific position
chart.applyTransaction({
add: [{ category: 'Item 3', value: 45 }],
addIndex: 2,
}); Removing Data Copy Link
Use the remove property to remove items from the dataset.
Items are matched by referential equality, meaning you must provide the exact object reference that exists in the data array.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
{ category: 'Item 3', value: 45 },
];
// Later, remove specific items by reference
const itemToRemove = data[0];
chart.applyTransaction({
remove: [itemToRemove],
}); Updating Data Copy Link
Use the update property to modify existing items.
First mutate the item in place, then pass the reference in the transaction.
// Keep a reference to the data items
const data = [
{ category: 'Item 1', value: 50 },
{ category: 'Item 2', value: 55 },
];
// Mutate the item in place
const itemToUpdate = data[1];
itemToUpdate.value = 100;
// Notify the chart of the change
chart.applyTransaction({
update: [itemToUpdate],
}); Combined Operations Copy Link
Multiple operations can be performed in a single transaction for efficiency.
chart.applyTransaction({
remove: [oldItems[0], oldItems[1]],
update: [modifiedItem],
add: [
{ category: 'Item 10', value: 62 },
{ category: 'Item 11', value: 58 },
],
});Operations are processed in order: add, then remove, then update.
Identifying Items by Key Copy Link
Set the dataIdKey chart option to a property name on your data items to identify them by that field instead of by object reference.
When dataIdKey is set:
- Remove operations only need the ID field on each item.
- Update operations match by ID and replace the existing datum with the new object.
- Add operations work the same as without
dataIdKey.
dataIdKey also determines the itemId exposed in many node events and states. See Item Identifiers for more details.
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
BarSeriesModule,
CategoryAxisModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { random } from "./seededRandom";
import clone from "clone";
interface DataItem {
id: string;
category: string;
value: number;
}
let nextId = 1;
function createItem() {
const id = `item-${nextId}`;
return {
id,
category: `Item ${nextId++}`,
value: Math.round(random() * 100),
};
}
function getInitialData() {
const items = [];
for (let i = 0; i < 20; i++) {
items.push(createItem());
}
return items;
}
const data = getInitialData();
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
NumberAxisModule,
]);
const ChartExample = defineComponent({
template: `
<div class="example-controls">
<div class="controls-row">
<button v-on:click="addItems()">Add 3 Items</button>
<button v-on:click="removeById()">Remove Last by ID</button>
<button v-on:click="updateById()">Update First by ID</button>
</div>
</div>
<ag-charts
ref="agCharts"
:options="options"
/>
`,
components: {
"ag-charts": AgCharts,
},
setup(props) {
const options = ref<AgChartOptions>({
dataIdKey: "id",
data,
series: [
{
type: "bar",
xKey: "category",
yKey: "value",
},
],
});
const agCharts = ref(null);
const addItems = () => {
const newItems = [];
for (let i = 0; i < 3; i++) {
newItems.push(createItem());
}
data.push(...newItems);
agCharts.value.chart.applyTransaction({ add: newItems });
};
const removeById = () => {
if (data.length === 0) return;
const lastItem = data.pop();
// Only need the ID field to remove
agCharts.value.chart.applyTransaction({ remove: [{ id: lastItem.id }] });
};
const updateById = () => {
if (data.length === 0) return;
// Create a brand-new object with the same ID
const existing = data[0];
const replacement = {
id: existing.id,
category: existing.category,
value: Math.round(random() * 100),
};
data[0] = replacement;
agCharts.value.chart.applyTransaction({ update: [replacement] });
};
return {
options,
agCharts,
addItems,
removeById,
updateById,
};
},
});
createApp(ChartExample).mount("#app");
export function createSeededRandom(seed = 42): () => number {
let state = seed;
return () => {
state = (state * 16807) % 2147483647;
return (state - 1) / 2147483646;
};
}
export const random = createSeededRandom();
- Add 3 Items: Appends 3 new items to the dataset.
- Remove Last by ID: Removes the last item using only its
idfield. - Update First by ID: Creates a new object with the same
idto replace the first item.
Setting dataIdKey Copy Link
const options = {
dataIdKey: 'id',
data: [
{ id: 'item-1', category: 'Category A', value: 42 },
{ id: 'item-2', category: 'Category B', value: 58 },
],
// ...
};The values of the dataIdKey field must be unique strings or numbers across the dataset.
Removing by ID Copy Link
When dataIdKey is set, remove items by passing objects containing only the ID field:
chart.applyTransaction({
remove: [{ id: 'item-1' }],
}); Updating by ID Copy Link
Pass a new object with the matching ID. The existing datum is fully replaced:
chart.applyTransaction({
update: [{ id: 'item-2', category: 'Category B', value: 99 }],
});Unlike reference-based updates where you mutate the original object, ID-based updates use replacement semantics — the chart stores the new object in place of the old one.
API Reference Copy Link
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Transaction object for performing incremental data updates. Used for efficient high frequency updates. By default, object identity is determined by referential equality. When `dataIdKey` is set on the chart options, items are matched by the specified ID field instead.
- add
unknown[] - Data items to add to the dataset. Use `addIndex` to control the insertion position, otherwise items are appended to the end.
- addIndex
number - Zero-based index at which to insert the `add` items. - If undefined or >= dataset length: items are appended to the end - If 0: items are prepended to the beginning - Otherwise: items are inserted at the specified position
- remove
unknown[] - Data items to remove from the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, only the ID field is needed on each item.
- update
unknown[] - Data items to update in the dataset. Items are matched by referential equality (object reference). When `dataIdKey` is set on the chart, items are matched by the ID field and the existing datum is replaced entirely by the new object.
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Properties available on the _AgChartInstanceInterface interface.
- applyTransaction required
Function - Apply a transaction to incrementally update the chart data without replacing the entire dataset. Returns a `Promise` that resolves once the transaction has been applied and rendered
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.
Configuration common to all charts.
- dataIdKey
DatumKey - The key of the property on each datum that contains its unique identifier. When specified, transactions will match items by this field instead of by object reference. The values of this field must be unique across the dataset.